unit FMain;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TFormMain = class(TForm)
    ButtonNewEmail: TButton;
    ButtonNewContact: TButton;
    ButtonDisplayFirstContact: TButton;
    ButtonDumpTasks: TButton;
    ButtonDumpNotCompletedTasks: TButton;
    ButtonEmailWithAttachment: TButton;
    procedure ButtonNewEmailClick(Sender: TObject);
    procedure ButtonNewContactClick(Sender: TObject);
    procedure ButtonDisplayFirstContactClick(Sender: TObject);
    procedure ButtonDumpTasksClick(Sender: TObject);
    procedure ButtonDumpNotCompletedTasksClick(Sender: TObject);
    procedure ButtonEmailWithAttachmentClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FormMain: TFormMain;

implementation

uses
  Outlook8_TLB;

{$R *.DFM}

procedure TFormMain.ButtonNewEmailClick(Sender: TObject);
var
  app: Application_;
  mi: MailItem;
begin
  app := CoApplication_.Create;
  mi := app.CreateItem(olMailItem) as MailItem;
  mi.To_ := 'berend@nothere.nl';
  mi.Subject := 'This is the subject';
  mi.Body := 'This is the message itself';
  mi.Send;
end;

procedure TFormMain.ButtonNewContactClick(Sender: TObject);
var
  app: Application_;
  ci: ContactItem;
begin
  app := CoApplication_.Create;
  ci := app.CreateItem(olContactItem) as ContactItem;
  ci.FullName := 'Test person';
  ci.Companies := 'NederWare';
  ci.Save;
end;

procedure TFormMain.ButtonDisplayFirstContactClick(Sender: TObject);
var
  app: Application_;
  ns: NameSpace;
  cf: MAPIFolder;
  ci: ContactItem;
begin
  app := CoApplication_.Create;
  ns := app.GetNameSpace('MAPI');
  cf := ns.GetDefaultFolder(olFolderContacts);
  ci := cf.Items.Item(1) as ContactItem;
  ci.Display(0);
end;

procedure TFormMain.ButtonDumpTasksClick(Sender: TObject);
var
  app: Application_;
  ns: NameSpace;
  tf: MAPIFolder;
  i: Items;
  j: integer;
  ti: TaskItem;
  f: TextFile;
  s: string;
begin
  app := CoApplication_.Create;
  ns := app.GetNameSpace('MAPI');
  tf := ns.GetDefaultFolder(olFolderTasks);
  i := tf.Items;
  AssignFile(f, 'tasks.txt');
  Rewrite(f);
  for j := 1 to i.Count do  begin
    ti := i.Item(j) as TaskItem;
    s := ti.Subject;
    writeln(f, s);
  end;
  CloseFile(f);
end;

procedure TFormMain.ButtonDumpNotCompletedTasksClick(Sender: TObject);
var
  app: Application_;
  ns: NameSpace;
  tf: MAPIFolder;
  i: Items;
  ri: Items;
  j: integer;
  ti: TaskItem;
  f: TextFile;
  s: string;
begin
  app := CoApplication_.Create;
  ns := app.GetNameSpace('MAPI');
  tf := ns.GetDefaultFolder(olFolderTasks);
  i := tf.Items;
  //You can also use strings
  //ri := i.Restrict('[Status]=''Not Started'' ' +
  //                 'or [Status]=''In Progress'' ' +
  //                 'or [Status]=''Waiting on someone else''');
  ri := i.Restrict('[Status]=0 ' +
                   'or [Status]=1 ' +
                   'or [Status]=3');
  AssignFile(f, 'tasks.txt');
  Rewrite(f);
  for j := 1 to ri.Count do  begin
    ti := ri.Item(j) as TaskItem;
    s := ti.Subject;
    writeln(f, s);
  end;
  CloseFile(f);
end;

procedure TFormMain.ButtonEmailWithAttachmentClick(Sender: TObject);
var
  app: Application_;
  mi: MailItem;
begin
  app := CoApplication_.Create;
  mi := app.CreateItem(olMailItem) as MailItem;
  mi.To_ := 'berend@nothere.nl';
  mi.Subject := 'Things to do';
  mi.Body := 'All active tasks are attached to this message.';
  mi.Attachments.Add('tasks.txt', olByValue, 0, 'To do list');
  mi.Send;
end;

end.
